/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.configuracioneccomerciales;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;

import com.rjconsultores.ventaboletos.entidad.CancelacionCtrl;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.MotivoCancelacion;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.PuntoVenta;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.MotivoCancelacionService;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.service.PuntoVentaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionCancelacion;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaConfiguracionCancelacionController")
@Scope("prototype")
public class BusquedaConfiguracionCancelacionController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<CancelacionCtrl> plwConfigCancelacion;
	@Autowired
	private PuntoVentaService puntoVentaService;
	@Autowired
	private MarcaService marcaService;
	@Autowired
	private MotivoCancelacionService motivoCancelacionService;
	@Autowired
	private OrgaoConcedenteService orgaoConcedenteService;
	private MyListbox cancelacionCtrlList;
	private Paging pagingCancelacion;
	private List<Marca> lsMarca;
	private List<MotivoCancelacion> lsMotivoCancelacion;
	private List<OrgaoConcedente> lsOrgaoConcedente;
	private Combobox cmbMarca;
	private Combobox cmbParadaDestino;
	private Combobox cmbParadaOrigem;
	private Combobox cmbPuntoVenta;
	private Combobox cmbMotivoCancelacion;
	private Combobox cmbOrgaoConcedente;

	public List<MotivoCancelacion> getLsMotivoCancelacion() {
		return lsMotivoCancelacion;
	}

	public void setLsMotivoCancelacion(List<MotivoCancelacion> lsMotivoCancelacion) {
		this.lsMotivoCancelacion = lsMotivoCancelacion;
	}

	public List<Marca> getLsMarca() {
		return lsMarca;
	}

	public void setLsMarca(List<Marca> lsMarca) {
		this.lsMarca = lsMarca;
	}

	public List<OrgaoConcedente> getLsOrgaoConcedente() {
		return lsOrgaoConcedente;
	}

	public void setLsOrgaoConcedente(List<OrgaoConcedente> lsOrgaoConcedente) {
		this.lsOrgaoConcedente = lsOrgaoConcedente;
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		lsOrgaoConcedente = orgaoConcedenteService.obtenerTodos();

		lsMarca = marcaService.buscarMarcaPorEmpresa(UsuarioLogado.getUsuarioLogado().getEmpresa());

		lsMotivoCancelacion = new ArrayList<MotivoCancelacion>();
		lsMotivoCancelacion.add(new MotivoCancelacion());
		lsMotivoCancelacion.addAll(motivoCancelacionService.obtenerTodosTipoMotivoB());

		cancelacionCtrlList.setItemRenderer(new RenderConfiguracionCancelacion());
		cancelacionCtrlList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				CancelacionCtrl cc = (CancelacionCtrl) cancelacionCtrlList.getSelected();
				verConfigCancelacion(cc);
			}
		});

		refreshLista();
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	private void verConfigCancelacion(CancelacionCtrl cc) {
		if (cc == null) {
			return;
		}

		Map args = new HashMap();
		args.put("cancelacionCtrl", cc);
		args.put("cancelacionCtrlList", cancelacionCtrlList);

		openWindow("/gui/configuraciones_comerciales/editarConfiguracionCancelacion.zul",
				Labels.getLabel("editarConfiguracionCancelacionController.window.title"), args, MODAL);
	}

	private void refreshLista() {
		HibernateSearchObject<CancelacionCtrl> configCancelacionBusqueda =
				new HibernateSearchObject<CancelacionCtrl>(CancelacionCtrl.class, pagingCancelacion.getPageSize());

		configCancelacionBusqueda.addFilterEqual("activo", Boolean.TRUE);

		Marca marca = (Marca) (cmbMarca.getSelectedItem() != null ? cmbMarca.getSelectedItem().getValue() : null);
		Parada paradaDestino = (Parada) (cmbParadaDestino.getSelectedItem() != null ? cmbParadaDestino.getSelectedItem().getValue() : null);
		Parada paradaOrigem = (Parada) (cmbParadaOrigem.getSelectedItem() != null ? cmbParadaOrigem.getSelectedItem().getValue() : null);
		PuntoVenta puntoVenta = (PuntoVenta) (cmbPuntoVenta.getSelectedItem() != null ? cmbPuntoVenta.getSelectedItem().getValue() : null);
		MotivoCancelacion motivoCancelacion = (MotivoCancelacion) (cmbMotivoCancelacion.getSelectedItem() != null ? cmbMotivoCancelacion.getSelectedItem().getValue() : null);
		OrgaoConcedente orgaoConcedente = (OrgaoConcedente) (cmbOrgaoConcedente.getSelectedItem() != null ? cmbOrgaoConcedente.getSelectedItem().getValue() : null);

		if (orgaoConcedente != null) {
			configCancelacionBusqueda.addFilterEqual("orgaoConcedente", orgaoConcedente);
		}

		if (marca != null) {
			configCancelacionBusqueda.addFilterEqual("marca", marca);
		}
		else{
			configCancelacionBusqueda.addFilterIn("marca", lsMarca);
		}

		if (paradaDestino != null) {
			configCancelacionBusqueda.addFilterEqual("paradaDestino", paradaDestino);
		}

		if (paradaOrigem != null) {
			configCancelacionBusqueda.addFilterEqual("paradaOrigem", paradaOrigem);
		}

		if (puntoVenta != null) {
			configCancelacionBusqueda.addFilterEqual("puntoVenta", puntoVenta);
		}

		if (motivoCancelacion != null) {
			configCancelacionBusqueda.addFilterEqual("motivoCancelacion", motivoCancelacion);
		}

		plwConfigCancelacion.init(configCancelacionBusqueda, cancelacionCtrlList, pagingCancelacion);

		if (cancelacionCtrlList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionCancelacionController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}

	public void onClick$btnPesquisa(Event ev) {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verConfigCancelacion(new CancelacionCtrl());
	}
}
